import 'dart:ffi';
import 'package:ffi/ffi.dart';
import 'package:argox/types.dart';

class Argox {
  Pointer<Utf8> pbuf = ''.padLeft(128).toNativeUtf8();
  Pointer<Int32> len1 = calloc<Int32>();
  Pointer<Int32> len2 = calloc<Int32>();
  late Pointer<Utf8> buf1;
  late Pointer<Utf8> buf2;
  late DynamicLibrary dylib;
  late Pointer<NativeFunction<A_Get_DLL_VersionAFunc>> _getDllVersionPointer;
  late A_Get_DLL_VersionA getDllVersion;
  late Pointer<NativeFunction<A_GetUSBBufferLenFunc>> _getUsbBufferLenPointer;
  late A_GetUSBBufferLen getUsbBufferLen;
  late Pointer<NativeFunction<A_EnumUSBFunc>> _enumUsbPointer;
  late A_EnumUSB _enumUsb;
  int enumUsb() => _enumUsb(pbuf);
  late Pointer<NativeFunction<A_GetUSBDeviceInfoFunc>> _getUsbDeviceInfoPointer;
  late A_GetUSBDeviceInfo _getUsbDeviceInfo;
  int getUsbDeviceInfo(int nPort) =>
      _getUsbDeviceInfo(nPort, buf1, len1, buf2, len2);
  late Pointer<NativeFunction<A_CreatePrnFunc>> _createPrnPointer;
  late A_CreatePrn _createPrn;
  int createPrn(int selection, String? filename) {
    if (selection == 12) {
      return _createPrn(selection, buf2);
    } else {
      return _createPrn(selection, filename!.toNativeUtf8());
    }
  }

  late Pointer<NativeFunction<A_CreateUSBPortFunc>> _createUsbPortPointer;
  late A_CreateUSBPort createUsbPort;
  late Pointer<NativeFunction<A_WriteDataFunc>> _writeDataPointer;
  late A_WriteData _writeData;
  int writeData(bool isIntermediate, String data) =>
      _writeData(isIntermediate ? 1 : 0, data.toNativeUtf8(), data.length);
  late Pointer<NativeFunction<A_ReadDataFunc>> _readDataPointer;
  late A_ReadData _readData;
  String readData(int size, int timeout) {
    pbuf = ''.padLeft(size).toNativeUtf8();
    _readData(pbuf, size, timeout);
    return pbuf.toDartString();
  }

  late Pointer<NativeFunction<A_Set_DebugDialogFunc>> _setDebugDialogPointer;
  late A_Set_DebugDialog setDebugDialog;
  late Pointer<NativeFunction<A_Set_UnitFunc>> _setUnitPointer;
  late A_Set_Unit _setUnit;
  int setUnit(String unit) => _setUnit(unit.codeUnitAt(0));
  late Pointer<NativeFunction<A_Set_SyssettingFunc>> _setSyssettingPointer;
  late A_Set_Syssetting setSyssetting;
  late Pointer<NativeFunction<A_Set_DarknessFunc>> _setDarknessPointer;
  late A_Set_Darkness setDarkness;
  late Pointer<NativeFunction<A_Del_GraphicFunc>> _delGraphicPointer;
  late A_Del_Graphic _delGraphic;
  int delGraphic(int mem_mode, String graphic) =>
      _delGraphic(mem_mode, graphic.toNativeUtf8());
  late Pointer<NativeFunction<A_Clear_MemoryFunc>> _clearMemoryPointer;
  late A_Clear_Memory clearMemory;
  late Pointer<NativeFunction<A_Set_LabelForSmartPrintFunc>>
      _setLabelForSmartPrintPointer;
  late A_Set_LabelForSmartPrint setLabelForSmartPrint;
  late Pointer<NativeFunction<A_Draw_BoxFunc>> _drawBoxPointer;
  late A_Draw_Box _drawBox;
  int drawBox(String mode, int x, int y, int width, int height, int top,
          int side) =>
      _drawBox(mode.codeUnitAt(0), x, y, width, height, top, side);
  late Pointer<NativeFunction<A_Draw_LineFunc>> _drawLinePointer;
  late A_Draw_Line _drawLine;
  int drawLine(String mode, int x, int y, int width, int height) =>
      _drawLine(mode.codeUnitAt(0), x, y, width, height);
  late Pointer<NativeFunction<A_Prn_TextFunc>> _prnTextPointer;
  late A_Prn_Text _prnText;
  int prnText(int x, int y, int ori, int font, int type, int hor_factor,
          int ver_factor, String mode, int numeric, String data) =>
      _prnText(x, y, ori, font, type, hor_factor, ver_factor,
          mode.codeUnitAt(0), numeric, data.toNativeUtf8());
  late Pointer<NativeFunction<A_Prn_Text_TrueTypeFunc>> _prnTextTrueTypePointer;
  late A_Prn_Text_TrueType _prnTextTrueType;
  int prnTextTrueType(
          int x,
          int y,
          int FSize,
          String FType,
          int Fspin,
          int FWeight,
          int FItalic,
          int FUnline,
          int FStrikeOut,
          String id_name,
          String data,
          int mem_mode) =>
      _prnTextTrueType(
          x,
          y,
          FSize,
          FType.toNativeUtf8(),
          Fspin,
          FWeight,
          FItalic,
          FUnline,
          FStrikeOut,
          id_name.toNativeUtf8(),
          data.toNativeUtf8(),
          mem_mode);
  late Pointer<NativeFunction<A_Prn_Text_TrueType_WFunc>>
      _prnTextTrueTypeWPointer;
  late A_Prn_Text_TrueType_W _prnTextTrueTypeW;
  late Pointer<NativeFunction<A_Prn_Text_TrueType_UniFunc>>
      _prnTextTrueTypeUniPointer;
  late A_Prn_Text_TrueType_Uni _prnTextTrueTypeUni;
  late Pointer<NativeFunction<A_Prn_Text_TrueType_UniBFunc>>
      _prnTextTrueTypeUniBPointer;
  late A_Prn_Text_TrueType_UniB _prnTextTrueTypeUniB;
  late Pointer<NativeFunction<A_Prn_BarcodeFunc>> _prnBarcodePointer;
  late A_Prn_Barcode _prnBarcode;
  int prnBarcode(int x, int y, int ori, String type, int narrow, int width,
          int height, String mode, int numeric, String data) =>
      _prnBarcode(x, y, ori, type.codeUnitAt(0), narrow, width, height,
          mode.codeUnitAt(0), numeric, data.toNativeUtf8());
  late Pointer<NativeFunction<A_Print_OutFunc>> _printOutPointer;
  late A_Print_Out printOut;
  late Pointer<NativeFunction<A_ClosePrnFunc>> _closePrnPointer;
  late A_ClosePrn closePrn;

  Argox() {
    len1.value = 128;
    len2.value = 128;
    buf1 = ''.padLeft(len1.value).toNativeUtf8();
    buf2 = ''.padLeft(len2.value).toNativeUtf8();
    dylib = DynamicLibrary.open('Winppla.dll');
    // Declaring functions
    _getDllVersionPointer = dylib
        .lookup<NativeFunction<A_Get_DLL_VersionAFunc>>('A_Get_DLL_VersionA');
    getDllVersion = _getDllVersionPointer.asFunction<A_Get_DLL_VersionA>();
    _getUsbBufferLenPointer = dylib
        .lookup<NativeFunction<A_GetUSBBufferLenFunc>>('A_GetUSBBufferLen');
    getUsbBufferLen = _getUsbBufferLenPointer.asFunction<A_GetUSBBufferLen>();
    _enumUsbPointer = dylib.lookup<NativeFunction<A_EnumUSBFunc>>('A_EnumUSB');
    _enumUsb = _enumUsbPointer.asFunction<A_EnumUSB>();
    _getUsbDeviceInfoPointer = dylib
        .lookup<NativeFunction<A_GetUSBDeviceInfoFunc>>('A_GetUSBDeviceInfo');
    _getUsbDeviceInfo =
        _getUsbDeviceInfoPointer.asFunction<A_GetUSBDeviceInfo>();
    _createPrnPointer =
        dylib.lookup<NativeFunction<A_CreatePrnFunc>>('A_CreatePrn');
    _createPrn = _createPrnPointer.asFunction<A_CreatePrn>();
    _createUsbPortPointer =
        dylib.lookup<NativeFunction<A_CreateUSBPortFunc>>('A_CreateUSBPort');
    createUsbPort = _createUsbPortPointer.asFunction<A_CreateUSBPort>();
    _writeDataPointer =
        dylib.lookup<NativeFunction<A_WriteDataFunc>>('A_WriteData');
    _writeData = _writeDataPointer.asFunction<A_WriteData>();
    _readDataPointer =
        dylib.lookup<NativeFunction<A_ReadDataFunc>>('A_ReadData');
    _readData = _readDataPointer.asFunction<A_ReadData>();
    _setDebugDialogPointer = dylib
        .lookup<NativeFunction<A_Set_DebugDialogFunc>>('A_Set_DebugDialog');
    setDebugDialog = _setDebugDialogPointer.asFunction<A_Set_DebugDialog>();
    _setUnitPointer =
        dylib.lookup<NativeFunction<A_Set_UnitFunc>>('A_Set_Unit');
    _setUnit = _setUnitPointer.asFunction<A_Set_Unit>();
    _setSyssettingPointer =
        dylib.lookup<NativeFunction<A_Set_SyssettingFunc>>('A_Set_Syssetting');
    setSyssetting = _setSyssettingPointer.asFunction<A_Set_Syssetting>();
    _setDarknessPointer =
        dylib.lookup<NativeFunction<A_Set_DarknessFunc>>('A_Set_Darkness');
    setDarkness = _setDarknessPointer.asFunction<A_Set_Darkness>();
    _delGraphicPointer =
        dylib.lookup<NativeFunction<A_Del_GraphicFunc>>('A_Del_Graphic');
    _delGraphic = _delGraphicPointer.asFunction<A_Del_Graphic>();
    _clearMemoryPointer =
        dylib.lookup<NativeFunction<A_Clear_MemoryFunc>>('A_Clear_Memory');
    clearMemory = _clearMemoryPointer.asFunction<A_Clear_Memory>();
    _setLabelForSmartPrintPointer =
        dylib.lookup<NativeFunction<A_Set_LabelForSmartPrintFunc>>(
            'A_Set_LabelForSmartPrint');
    setLabelForSmartPrint =
        _setLabelForSmartPrintPointer.asFunction<A_Set_LabelForSmartPrint>();
    _drawBoxPointer =
        dylib.lookup<NativeFunction<A_Draw_BoxFunc>>('A_Draw_Box');
    _drawBox = _drawBoxPointer.asFunction<A_Draw_Box>();
    _drawLinePointer =
        dylib.lookup<NativeFunction<A_Draw_LineFunc>>('A_Draw_Line');
    _drawLine = _drawLinePointer.asFunction<A_Draw_Line>();
    _prnTextPointer =
        dylib.lookup<NativeFunction<A_Prn_TextFunc>>('A_Prn_Text');
    _prnText = _prnTextPointer.asFunction<A_Prn_Text>();
    _prnTextTrueTypePointer = dylib
        .lookup<NativeFunction<A_Prn_Text_TrueTypeFunc>>('A_Prn_Text_TrueType');
    _prnTextTrueType =
        _prnTextTrueTypePointer.asFunction<A_Prn_Text_TrueType>();
    _prnTextTrueTypeWPointer =
        dylib.lookup<NativeFunction<A_Prn_Text_TrueType_WFunc>>(
            'A_Prn_Text_TrueType_W');
    _prnTextTrueTypeW =
        _prnTextTrueTypeWPointer.asFunction<A_Prn_Text_TrueType_W>();
    _prnTextTrueTypeUniPointer =
        dylib.lookup<NativeFunction<A_Prn_Text_TrueType_UniFunc>>(
            'A_Prn_Text_TrueType_Uni');
    _prnTextTrueTypeUni =
        _prnTextTrueTypeUniPointer.asFunction<A_Prn_Text_TrueType_Uni>();
    _prnTextTrueTypeUniBPointer =
        dylib.lookup<NativeFunction<A_Prn_Text_TrueType_UniBFunc>>(
            'A_Prn_Text_TrueType_UniB');
    _prnTextTrueTypeUniB =
        _prnTextTrueTypeUniBPointer.asFunction<A_Prn_Text_TrueType_UniB>();
    _prnBarcodePointer =
        dylib.lookup<NativeFunction<A_Prn_BarcodeFunc>>('A_Prn_Barcode');
    _prnBarcode = _prnBarcodePointer.asFunction<A_Prn_Barcode>();
    _printOutPointer =
        dylib.lookup<NativeFunction<A_Print_OutFunc>>('A_Print_Out');
    printOut = _printOutPointer.asFunction<A_Print_Out>();
    _closePrnPointer =
        dylib.lookup<NativeFunction<A_ClosePrnFunc>>('A_ClosePrn');
    closePrn = _closePrnPointer.asFunction<A_ClosePrn>();
  }
}
